<template>
  <div>
    <el-form label-position="top" class="filter-form" size="large">
      <el-row :gutter="40">
        <el-col :xs="24" :sm="24" :lg="7">
          <el-form-item label="Status Petani" class="filter-form__label">
            <el-select v-model="params.status" class="ritx-select">
              <el-option label="Semua" value=""></el-option>
              <el-option label="Baru" value="1"></el-option>
              <el-option label="Verifikasi" value="2"></el-option>
              <el-option label="Registrasi ID" value="3"></el-option>
              <el-option label="Registrasi Lahan" value="4"></el-option>
              <el-option label="Registrasi Komoditas" value="5"></el-option>
              <el-option label="Aktif" value="6"></el-option>
            </el-select>
          </el-form-item>
          <el-form-item label="Jenis Kelamin" class="filter-form__label">
            <el-select v-model="params.gender" class="ritx-select">
              <el-option label="Semua" value=""></el-option>
              <el-option label="Pria" value="0"></el-option>
              <el-option label="Wanita" value="1"></el-option>
            </el-select>
          </el-form-item>
          <!--
                    <el-form-item label="Aktivitas Aplikasi">
                        <el-checkbox-group v-model="params.apps" class="ritx-checkbox" text-color="#74bd40" fill="#ffffff">
                            <el-checkbox label="Cuaca"></el-checkbox>
                            <el-checkbox label="Artikel"></el-checkbox>
                            <el-checkbox label="Forum"></el-checkbox>
                            <el-checkbox label="Chatbot" disabled=""></el-checkbox>
                            <el-checkbox label="Rekomendasi" disabled=""></el-checkbox>
                        </el-checkbox-group>
                    </el-form-item>-->
        </el-col>
        <el-col :xs="24" :sm="24" :lg="7">
          <el-form-item label="Lokasi Petani">
            <el-select
              v-model="params.city"
              multiple
              filterable
              remote
              reserve-keyword
              class="ritx-autocomplete"
              placeholder="Tulis Lokasi"
              :remote-method="searchLocation"
              @change="change"
              :loading="loading_location"
            >
              <el-option
                v-for="item in options_location"
                :key="item.value"
                :label="item.label"
                class="ritx-autocomplete-dropdown"
                :value="item.value"
              >
              </el-option>
            </el-select>
          </el-form-item>
          <el-form-item label="Komoditas Yang Ditanam">
            <el-select
              v-model="params.commodity"
              multiple
              filterable
              remote
              reserve-keyword
              class="ritx-autocomplete"
              placeholder="Tulis Komoditas"
              :remote-method="searchComodity"
              :loading="loading_commodity"
            >
              <el-option
                v-for="item in options_commodity"
                :key="item.value"
                :label="item.label"
                class="ritx-autocomplete-dropdown"
                :value="item.value"
              >
              </el-option>
            </el-select>
          </el-form-item>
        </el-col>
        <el-col :xs="24" :sm="24" :lg="7">
          <el-form-item label="Tanggal">
            <el-date-picker class="from" size="small" v-model="params.value1" align="left" type="date" placeholder="Dari"> </el-date-picker>
            <el-date-picker class="to" size="small" v-model="params.value2" align="right" type="date" placeholder="Sampai"> </el-date-picker>
          </el-form-item>
        </el-col>
        <el-col :xs="24" :sm="24" :lg="3">
          <el-form-item>
            <el-button type="ritx-primary" v-on:click="submit">Simpan</el-button>
          </el-form-item>
        </el-col>
      </el-row>
    </el-form>
  </div>
</template>
<script>
import { getCities } from '@/api/city';
import { getCommodities } from '@/api/commodity';
export default {
  name: 'FilterComponent',
  data() {
    return {
      params: {
        gender: '',
        status: '',
        apps: [],
        city: [],
        commodity: [],
        value1: '',
        value2: ''
      },
      options_location: [],
      loading_location: false,
      options_commodity: [],
      loading_commodity: false
    };
  },
  methods: {
    searchLocation(query) {
      if (query !== '') {
        this.loading_location = true;
        setTimeout(() => {
          this.loading_location = false;
          getCities(query).then(response => {
            this.options_location = response.data.data.map(item => {
              return { value: item.id, label: item.city_name };
            });
          });
        }, 200);
      } else {
        this.options_location = [];
      }
    },
    searchComodity(query) {
      if (query !== '') {
        this.loading_commodity = true;
        setTimeout(() => {
          this.loading_commodity = false;
          getCommodities(query).then(response => {
            this.options_commodity = response.data.data.map(item => {
              return { value: item.id, label: item.plant_name };
            });
          });
        }, 200);
      } else {
        this.options_commodity = [];
      }
    },
    submit() {
      this.updateParams(this.params);
    },
    updateParams(params) {
      this.$emit('updateParams', params);
    },
    change(e) {
      console.log(e);
    }
  }
};
</script>
<style rel="stylesheet/scss" lang="scss" scoped>
@import '@/styles/variables.scss';
.filter-form {
  background: #f9fbf8;
  margin: 0 -30px 0 -30px;
  padding: 20px 30px 0 30px;
  .el-button {
    &--ritx-primary {
      margin-top: 38px;
    }
  }
}
.el-select-dropdown__item.selected {
  color: $ritx-greyish-brown;
}
.from{
  background-color: #e9f1e4;
  color: #4a4a4a;
  font-size: 14px;
  border: solid 1px #086939;
  border-radius: 4px;
  width: 150px;
  height: 40px;
  padding: 2px
}
.to{
  background-color: #e9f1e4;
  color: #4a4a4a;
  font-size: 14px;
  border: solid 1px #086939;
  border-radius: 4px;
  width: 150px;
  height: 40px;
  padding: 2px
}
</style>
